#include <windows.h>
#include <commctrl.h>
#include "main.h"
/* Desarrollamos para XP y posterior */
#define _WIN32_WINNT        0x0501
#define _WIN32_IE           0x0501
/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SBWndProc(HWND, UINT, WPARAM, LPARAM, UINT_PTR, DWORD_PTR);
int MenuBar(HWND);
/*  Make the class name into a global variable  */
TCHAR tszClassName[ ] = TEXT("WindowsApp");
HINSTANCE hInstance;
HWND hwnd, hStatusBar, hStatusButton, hEdit;
/* Punto de Entrada WinMain */
int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszArgument, int nFunsterStil)
{
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    InitCommonControlsEx();
//    CREATESTRUCT cs;
    INITCOMMONCONTROLSEX iccex = {
        sizeof(INITCOMMONCONTROLSEX), ICC_BAR_CLASSES
        };
    /*if(!InitCommonControlsEx(&iccex)) {
       return 0;
      }*/

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = tszClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_HAND);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           tszClassName,        /* Classname */
           TEXT("Programa"),    /* Title Text */
           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           550,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    MenuBar(hwnd);
    ShowWindow (hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HMENU hmenu = LoadMenu(hInstance, "context");
//    CREATESTRUCT cs;
    HFONT hfont;
    HWND hButt1, hButt2;

    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
        {
            int SetStatusParts[ ] = {70, 275, 350, 415, -1};
            hfont = CreateFont(13, 0, 0, 0, 300, FALSE, FALSE, FALSE, DEFAULT_CHARSET,
              OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Arial");
            /* Crea un TrackBar */
            HWND hTrackBar = CreateWindow(TRACKBAR_CLASS, NULL, WS_VISIBLE | WS_CHILD,
               20, 20, 245, 40, hwnd, NULL, hInstance, NULL);
            /* Crea un cuadro Edit */
            hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, "Escriba aqu",
               WS_VISIBLE | WS_CHILD | ES_MULTILINE | ES_WANTRETURN | WS_VSCROLL,
               20, 70, 245, 210, hwnd, (HMENU)ID_EDIT, hInstance, NULL);
            SendMessage(hEdit, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
            /* Crea una barra de estado */
            hStatusBar = CreateWindowEx(0, STATUSCLASSNAME, "",
               WS_VISIBLE | WS_CHILD | SBARS_SIZEGRIP, 0, 0, 0, 0,
               hwnd, (HMENU)ID_STATUSBAR, hInstance, NULL);
            /* Envia un mensaje para definir en cuntas partes se va a dividir */
            SendMessage(hStatusBar, SB_SETPARTS, 5, (LPARAM)SetStatusParts);
            /* Muestra un texto, en la seccin n+1 */
            SendMessage(hStatusBar, SB_SETTEXT, 1, (LPARAM)"Statusbar");
            /* Creamos un boton, hijo de la barra de estado */
            hStatusButton = CreateWindowEx(0, WC_BUTTON, TEXT("Pulse"), WS_VISIBLE | WS_CHILD,
               0, 0, 70, 24, hStatusBar, (HMENU)ID_STATUSBUTTON, hInstance, NULL);
            /* Cambiamos su diseo de fuente */
            SendMessage(hStatusButton, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));

            /* Establecemos una subclase para la barra de estado */
            SetWindowSubclass(hStatusBar, SBWndProc, 0, 0);

            hButt1 = CreateWindowEx(0, WC_BUTTON, "Objetos", WS_VISIBLE | WS_CHILD,
               275, 20, 250, 40, hwnd, (HMENU)ID_BUTTON_1, hInstance, NULL);
            SendMessage(hButt1, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
            hButt2 = CreateWindowEx(0, WC_BUTTON, "Bolsa en linea", WS_VISIBLE | WS_CHILD,
               275, 70, 250, 40, hwnd, (HMENU)ID_BUTTON_2, hInstance, NULL);
            SendMessage(hButt2, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));

            HWND hElem = CreateWindowEx(0, WC_LISTBOX, "", WS_VISIBLE | WS_CHILD,
               275, 120, 250, 170, hwnd, NULL, hInstance, NULL);

            return 1;
        }
        break;
        case WM_SIZE:
        {
            RECT rectStatus;
            UINT uStatusHeight;

            /* Mensaje de tamao a barra de estado */
            SendMessage(hStatusBar, WM_SIZE, 0, 0);
            /* Calcula cunto hay que modificar */
            GetWindowRect(hStatusBar, &rectStatus);
            uStatusHeight = rectStatus.bottom - rectStatus.top;
            MoveWindow(hStatusBar, 0, 0, 0, 0, TRUE);
        }
        break;
        case WM_CONTEXTMENU:
            TrackPopupMenuEx(GetSubMenu(hmenu, 0),
               TPM_CENTERALIGN | TPM_HORIZONTAL | TPM_RIGHTBUTTON, LOWORD(lParam),
               HIWORD(lParam), hwnd, NULL);
            break;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case ID_BUTTON_1:
                    WinExec((LPSTR)"CHARMAP", (UINT)2);
                    break;
                case ID_BUTTON_2:
                    WinExec((LPSTR)"netsh", (UINT)1);
                    break;
                case CM_NEWWIN:
                    WinExec((LPCSTR)"sb.exe", (UINT)1);
                    break;
                case CM_HELP:
                    SendMessage(hwnd, WM_HELP, 0, 0);
                    break;
                case CM_ABOUT:
                    MessageBox(hwnd, TEXT("Creado por Alguien, en algn lugar."), "S.editor",
                       MB_OK | MB_ICONINFORMATION | MB_HELP);
                    break;
                case CM_QUIT:
                    int mb = MessageBox(hwnd, "Desea salir?", "",
                       MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON1 | MB_HELP);
                    if (mb == IDYES){
                       PostMessage(hwnd, WM_CLOSE, 0, 0);
                       }
                    break;
            }
            break;
        case WM_HELP:/* Ayuda definida en <winuser.h> */
            WinHelp(hwnd, (LPCSTR)"ayuda.html", HELP_INDEX, (DWORD)0);
            break;
        case WM_DESTROY:
            RemoveWindowSubclass(hStatusButton, SBWndProc, 0);
            DeleteObject(hfont);
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                       /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
/* Subclase para la barra de estado que contiene un botn */
LRESULT CALLBACK SBWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam,
                                UINT_PTR uIdSubclass, DWORD_PTR dwRefData)
{
    if(WM_COMMAND == message && ID_STATUSBUTTON == LOWORD(wParam))
    {
        /* Procesamos el botn ID_STATUSBUTTON */
        MessageBox(hWnd, "Ha pulsado este botn. Felicidades!", "", MB_OK);
        /* Enviamos a la cola de mensajes de la ventana pariente (principal)
           los del botn ID_STATUSBUTTON */
        PostMessage(GetParent(hwnd), message, wParam, lParam);
        return 0;
    }
    /* Deja que la ventana procese con normalidad los dems mensajes */
    return DefSubclassProc(hWnd, message, wParam, lParam);
}
/* Funcion que crea el men */
int MenuBar(HWND hwnd)
{
    /* Declaracin de las variables de los popups */
    HMENU menubar = CreateMenu();
    HMENU hmenu1 = CreateMenu();
    /* Elementos del men */
    AppendMenu(menubar, MF_STRING, CM_NEWWIN, "&Nueva ventana");
    AppendMenu(menubar, MF_STRING|MF_POPUP, (UINT)hmenu1, "Acciones");
    AppendMenu(hmenu1, MF_STRING, ID_BUTTON_1, "Objetos");
    AppendMenu(hmenu1, MF_STRING, ID_BUTTON_2, "Informacion de la Bolsa en lnea");
    AppendMenu(menubar, MF_STRING, CM_HELP, "Ayuda");
    AppendMenu(menubar, MF_STRING, CM_ABOUT, "Autores");
    AppendMenu(menubar, MF_STRING, CM_QUIT, "Salir");
    /* Configuramos como barra de men a la variable <menubar>, en la ventana <hwnd>*/
    SetMenu(hwnd, menubar);
    return 0;
}
